﻿using System;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;
using Plugin.BxlMpXamarinSDK;
using Plugin.BxlMpXamarinSDK.Abstractions;

namespace XamarinMpSDKDemo
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class PrinterSelectionPage : ContentPage
    {
        public bool isOn { get; set; }

        protected override void OnAppearing()
        {
            InitConnectionInfo();
        }
        public PrinterSelectionPage()
        {
            InitializeComponent();
        }

        public async void InitConnectionInfo()
        {
            MposLookup mPosLookup = MPosLookupUtil.Current;

            var timeout = 1; /*second*/
            var interfaceType = MPosInterfaceType.MPOS_INTERFACE_BLUETOOTH;
            //var interfaceType = MPosInterfaceType.MPOS_INTERFACE_WIFI;
            //var interfaceType = MPosInterfaceType.MPOS_INTERFACE_ETHERNET;

            var result = await mPosLookup.refreshDeivcesList((int)interfaceType, timeout /*second*/);

            if (result == (int)MPosResult.MPOS_SUCCESS){
                var deviceList = mPosLookup.getDeviceList((int)interfaceType);
                lstView.ItemsSource = deviceList;
            }
            else{
                await DisplayAlert("No Items", "No Device found", "OK");
                await Navigation.PopAsync();
                return;
            }
        }

        async void OnSelection(object sender, SelectedItemChangedEventArgs e)
        {
            if (e.SelectedItem == null)
                return;

            var info = e.SelectedItem as MposConnectionInformation;

            if (info != null){
                //await DisplayAlert("Item Selected", info.MacAddress.ToString(), "OK");
                var prevPage = BindingContext as Page;
                prevPage.BindingContext = info;
            }

            await Navigation.PopAsync();
        }
    }
}
